package de.popforge.cubicvr.gui
{
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import mx.effects.Zoom;
	import flash.events.MouseEvent;
	import flash.display.SimpleButton;

	public class ControlPanel extends Sprite
	{
		[Embed(source='/assets/assets.swf#control_pattern')]        public var AssetPattern: Class;
		//[Embed(source='/assets/assets.swf#control_logo')]           public var AssetLogo: Class;
		//[Embed(source='/assets/assets.swf#control_info_normal')]    public var AssetInfoNormal: Class;
		//[Embed(source='/assets/assets.swf#control_info_active')]    public var AssetInfoActive: Class;
		[Embed(source='/assets/assets.swf#control_zoom')]           public var AssetZoom: Class;
		[Embed(source='/assets/assets.swf#control_zoomIn_normal')]  public var AssetZoomInNormal: Class;
		[Embed(source='/assets/assets.swf#control_zoomIn_active')]  public var AssetZoomInActive: Class;
		[Embed(source='/assets/assets.swf#control_zoomOut_normal')] public var AssetZoomOutNormal: Class;
		[Embed(source='/assets/assets.swf#control_zoomOut_active')] public var AssetZoomOutActive: Class;
		
		public var onZoom: Function;
		
		private var pattern: Bitmap;
		private var zoom: Bitmap;
		private var zoomIn: SimpleButton;
		private var zoomOut: SimpleButton;
		//private var info: SimpleButton;
		
		public function ControlPanel()
		{
			//-- BAR BACKGROUND
			pattern = new AssetPattern();
			addChild( pattern );
			
			//-- LEFT ALIGN LOGO
			//addChild( new AssetLogo() );
			
			//-- RIGHT ALIGN INFO BUTTON
			//info = new SimpleButton();
			//info.upState = info.overState = new AssetInfoNormal();
			//info.downState = new AssetInfoActive();
			//info.hitTestState = info.upState;
			//info.useHandCursor = true;
			//addChild( info );
			
			//-- CENTER ALIGNED ZOOM
			zoom = new AssetZoom();
			addChild( zoom );
			
			//-- ZOOM-IN BUTTON
			zoomIn = new SimpleButton();
			zoomIn.upState = zoomIn.overState = new AssetZoomInNormal();
			zoomIn.downState = new AssetZoomInActive();
			zoomIn.hitTestState = zoomIn.upState;
			zoomIn.useHandCursor = true;
			
			addChild( zoomIn );
			zoomIn.addEventListener( MouseEvent.MOUSE_DOWN, onZoomInDown );
			zoomIn.addEventListener( MouseEvent.MOUSE_UP, onZoomInUp );
			
			//-- ZOOM-OUT BUTTON
			zoomOut = new SimpleButton();
			zoomOut.upState = zoomOut.overState = new AssetZoomOutNormal();
			zoomOut.downState = new AssetZoomOutActive();
			zoomOut.hitTestState = zoomOut.upState;
			zoomOut.useHandCursor = true;
			
			addChild( zoomOut );
			zoomOut.addEventListener( MouseEvent.MOUSE_DOWN, onZoomOutDown );
			zoomOut.addEventListener( MouseEvent.MOUSE_UP, onZoomOutUp );
		}
		
		public function resize( width: uint ): void
		{
			pattern.width = width;
			//info.x = width - info.width - 2;
			zoom.x = ( width - zoom.width ) >> 1;
			zoomIn.x = zoom.x - zoomIn.width;
			zoomOut.x = zoom.x + zoom.width;
		}
		
		private function onZoomInDown( event: MouseEvent ): void
		{
			onZoom( 1 );
		}
		
		private function onZoomOutDown( event: MouseEvent ): void
		{
			onZoom( -1 );
		}
		
		private function onZoomInUp( event: MouseEvent ): void
		{
			onZoom( 0 );
		}
		
		private function onZoomOutUp( event: MouseEvent ): void
		{
			onZoom( 0 );
		}
	}
}