package de.popforge.cubicvr.smart3d
{
	public class Frustum
	{
		public var top: Plane;
		public var left: Plane;
		public var bottom: Plane;
		public var right: Plane;
		
		private var eyeAngle: Number;
		
		public function Frustum( screenWidth: Number, screenHeight: Number, eyeAngle: Number )
		{
			this.eyeAngle = eyeAngle;
			
			var w2e: Number = ( screenWidth / 2 ) / eyeAngle;
			var h2e: Number = ( screenHeight / 2 ) / eyeAngle;
			
			left = new Plane
			(
				new Vector( 0, 0, 0 ),
				new Vector( -w2e, -h2e, 1 ),
				new Vector( -w2e,  h2e, 1 )
			);
			
			top = new Plane
			(
				new Vector( 0, 0, 0 ),
				new Vector(  w2e, -h2e, 1 ),
				new Vector( -w2e, -h2e, 1 )
			);
			
			bottom = new Plane
			(
				new Vector( 0, 0, 0 ),
				new Vector( -w2e, h2e, 1 ),
				new Vector(  w2e, h2e, 1 )
			);
			
			right = new Plane
			(
				new Vector( 0, 0, 0 ),
				new Vector( w2e,  h2e, 1 ),
				new Vector( w2e, -h2e, 1 )
			);
		}
		
		public function setSize( screenWidth: Number, screenHeight: Number ): void
		{
			var w2e: Number = ( screenWidth / 2 ) / eyeAngle;
			var h2e: Number = ( screenHeight / 2 ) / eyeAngle;
			
			left.v0.tx = 0;
			left.v0.ty = 0;
			left.v0.tz = 0;
			left.v1.tx = -w2e;
			left.v1.ty = -h2e;
			left.v1.tz = 1;
			left.v2.tx = -w2e;
			left.v2.ty = h2e;
			left.v2.tz = 1;
			left.abcd();
			
			top.v0.tx = 0;
			top.v0.ty = 0;
			top.v0.tz = 0;
			top.v1.tx = w2e;
			top.v1.ty = -h2e;
			top.v1.tz = 1;
			top.v2.tx = -w2e;
			top.v2.ty = -h2e;
			top.v2.tz = 1;
			top.abcd();
			
			bottom.v0.tx = 0;
			bottom.v0.ty = 0;
			bottom.v0.tz = 0;
			bottom.v1.tx = -w2e;
			bottom.v1.ty = h2e;
			bottom.v1.tz = 1;
			bottom.v2.tx = w2e;
			bottom.v2.ty = h2e;
			bottom.v2.tz = 1;
			bottom.abcd();
			
			right.v0.tx = 0;
			right.v0.ty = 0;
			right.v0.tz = 0;
			right.v1.tx = w2e;
			right.v1.ty = h2e;
			right.v1.tz = 1;
			right.v2.tx = w2e;
			right.v2.ty = -h2e;
			right.v2.tz = 1;
			right.abcd();
		}
	}
}