package de.popforge.cubicvr.smart3d
{
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import de.popforge.cubicvr.CubicVR;
	import flash.display.Bitmap;
	import flash.display.DisplayObjectContainer;
	
	public class HotSpot extends Vertex
	{
		private var listener: CubicVR;
		private var icon: Bitmap;
		
		public var sensitivRadius: Number;
		
		public var action: String;
		public var target: String;
		
		[Embed(source='/assets/assets.swf#hotspot_icon')] public var Icon: Class;
		
		public function HotSpot( listener: CubicVR, x: Number, y: Number, z: Number, sensitivRadius: Number, action: String, target: String )
		{
			super( x, y, z, 0, 0 );	// uv are unused
			
			this.listener = listener;
			
			this.sensitivRadius = sensitivRadius;
			this.action = action;
			this.target = target;
			
			icon = new Icon();
		}
		
		public function doAction(): void
		{
			switch( action )
			{
				case 'navigateToURL':
				
					navigateToURL( new URLRequest( target ), '_blank' );
					break;
					
				case 'navigateToCube':
				
					listener.requestCube( target );
					break;
			}
		}
		
		public function show( displayObject: DisplayObjectContainer ): void
		{
			if( !displayObject.contains( icon ) )
			{
				displayObject.addChild( icon );
			}
			
			icon.x = sx - 6;
			icon.y = sy - 6;
		}
		
		public function hide( displayObject: DisplayObjectContainer ): void
		{
			if( displayObject.contains( icon ) )
			{
				displayObject.removeChild( icon );
			}
		}
		
		public function toString(): String
		{
			return 'HotSpot x: ' + tx + ' y: ' + ty + ' z: ' + tz;
		}
	}
}