package de.popforge.cubicvr.smart3d
{
	public class Plane
	{
		public var v0: Vector;
		public var v1: Vector;
		public var v2: Vector;
		
		public var a: Number;
		public var b: Number;
		public var c: Number;
		public var d: Number;
		
		public function Plane( v0: Vector, v1: Vector, v2: Vector )
		{
			this.v0 = v0;
			this.v1 = v1;
			this.v2 = v2;
			
			abcd();
		}
		
		public function abcd(): void
		{
			var rx1: Number = v1.tx - v0.tx;
			var ry1: Number = v1.ty - v0.ty;
			var rz1: Number = v1.tz - v0.tz;
			
			var rx2: Number = v2.tx - v0.tx;
			var ry2: Number = v2.ty - v0.ty;
			var rz2: Number = v2.tz - v0.tz;

			a = ry1 * rz2 - ry2 * rz1;
			b = rz1 * rx2 - rz2 * rx1;
			c = rx1 * ry2 - rx2 * ry1;
			
			var l: Number = Math.sqrt( a * a + b * b + c * c );
			
			a /= l;
			b /= l;
			c /= l;
			
			d = a * v1.tx + b * v1.ty + c * v1.tz;
		}
	}
}