package de.popforge.cubicvr.smart3d
{
	import flash.display.BitmapData;
	import flash.geom.Point;

	public class PolyClipper
	{
		static public function clipFrustum( frustum: Frustum, cvert: Array ): void
		{
			if( cvert.length > 2 )clipPlane( frustum.left, cvert );
			else return;
			if( cvert.length > 2 )clipPlane( frustum.bottom, cvert );
			else return;
			if( cvert.length > 2 )clipPlane( frustum.right, cvert );
			else return;
			if( cvert.length > 2 )clipPlane( frustum.top, cvert );
			else return;
		}
		
		static private function clipPlane( plane: Plane, clipped: Array ): void
		{
			var source: Array = clipped.splice( 0 );

			var p0: Vertex;
			var p1: Vertex;
			
			//-- PLANE EQUATION
			var a: Number = plane.a;
			var b: Number = plane.b;
			var c: Number = plane.c;
			var d: Number = plane.d;
			
			//-- INTERSECTION
			var clipVertex: Vertex;
		
			var d0: Number;
			var d1: Number;
			var m: Number;			
			
			var k: int = source.length;
			var i: int;
			var j: int;
			
			for( j = k - 1, i = 0 ; i < k ; j = i, i++ )
			{
				p0 = source[j];
				p1 = source[i];
				
				d0 = a * p0.tx + b * p0.ty + c * p0.tz - d;
				d1 = a * p1.tx + b * p1.ty + c * p1.tz - d;
				
				if( d0 <= 0 || d1 <= 0 )
				{
					if( d1 > 0 )
					{
						m = d1 / ( d1 - d0 );
						
						clipVertex = new Vertex
						(
							p1.tx + ( p0.tx - p1.tx ) * m,
							p1.ty + ( p0.ty - p1.ty ) * m,
							p1.tz + ( p0.tz - p1.tz ) * m,
							p1.u + ( p0.u - p1.u ) * m,
							p1.v + ( p0.v - p1.v ) * m
						);

						clipped.push( clipVertex );
					}
					else if( d0 > 0 )
					{
						m = d1 / ( d1 - d0 );

						clipVertex = new Vertex
						(
							p1.tx + ( p0.tx - p1.tx ) * m,
							p1.ty + ( p0.ty - p1.ty ) * m,
							p1.tz + ( p0.tz - p1.tz ) * m,
							p1.u + ( p0.u - p1.u ) * m,
							p1.v + ( p0.v - p1.v ) * m
						);

						clipped.push( clipVertex );
						clipped.push( p1 );
					}
					else
					{
						clipped.push( p1 );
					}
				}
			}
		}
	}
}